%MATRIX1
% Generation of matrix A1
% Matrix generation by flux evaluation
% Straightforward but in MATLAB inefficient implementation
% Gives computing time on screen

tic	% Start clock

n = J*K; z = zeros(n,1); d = [-J  -1  0  1  J];
A1 = spdiags([ z  z  z  z  z], d',n,n);   % Preallocation as sparse matrix

for k = 1:K				   % Loop over vertical faces
  m = 1 + (k-1)*J;     A1(m,m) = A1(m,m) + dy(k);
end
for k = 1:K				   % Loop over vertical faces
  m1 = (k-1)*J; m = 1 + m1;		   
  a = - dy(k)/2 + dy(k)*Da/dx;		   % Cell face  
  b = - dy(k)/2 - dy(k)*Da/dx;		   %   fluxes
  for j = 2:J
    m = j + m1;  
    A1(m-1,m-1) = A1(m-1,m-1) + a;    A1(m-1,m) = A1(m-1,m) + b;
    A1(m,m-1)   = A1(m,m-1)   - a;      A1(m,m) = A1(m,m)   - b;
  end
  m = J+m1; A1(m,m) =  A1(m,m) + 2*Da*dy(k)/dx;
end
for j=1:J				% Loop over horizontal faces;
  m = j; A1(m,m) = A1(m,m) + 2*D*dx/dy(1);
  for k = 2:K
    m = j + (k-1)*J;     	    a = 2*dx*D/(dy(k) + dy(k-1));
    A1(m-J,m-J) = A1(m-J,m-J) + a;    A1(m-J,m) = A1(m-J,m) - a;
    A1(m,m-J)   = A1(m,m-J)   - a;    A1(m,m)   = A1(m,m)   + a;
  end
end

time = toc; disp(['matrix A1 time = ',num2str(time)])
