%MY_CHOLINC
% Incomplete Cholesky decomposition
% Laplacian on uniform grid, two or three dimensions

% Copyright 2001 P. Wesseling
% This program and its subprograms may be freely used, modified and distributed
% under the GNU General Public License: http://www.gnu.org/copyleft/gpl.html

% Theory is given in Chapter 6 of
%	Elements of Computational Fluid Dynamics
%	Lecture Notes by P. Wesseling
%	Department of Applied Mathematical Analysis, ITS, TU Delft
% See http://ta.twi.tudelft.nl/nw/users/wesseling/

if dim == 2
  d = zeros(n^2,1);
  d(1) = A(1,1);
  for j = 2:n
    d(j) = A(j,j) -A(j-1,j)^2/d(j-1);
  end
  for j = n+1:n^2
    d(j) = A(j,j) - A(j-1,j)^2/d(j-1)-A(j-n,j)^2/d(j-n);
  end
  B = spdiags(-e ,-1 ,n,n);
  L = (kron(I,B) + kron(B,I) + spdiags(d,0,n^2,n^2))...
	*spdiags(1./sqrt(d),0,n^2,n^2);
else
  n2 = n^2; n3=n^3; d = zeros(n^3,1);
  d(1) = A(1,1);
  for j = 2:n
    d(j) = A(j,j) -A(j-1,j)^2/d(j-1);
  end
  for j = n+1:n2
    d(j) = A(j,j) - A(j-1,j)^2/d(j-1)-A(j-n,j)^2/d(j-n);
  end
  for j = n2+1:n3
    d(j) = A(j,j) - A(j-1,j)^2/d(j-1) - A(j-n,j)^2/d(j-n)...
         - A(j-n2,j)^2/d(j-n2);
  end
  B = spdiags(-e ,-1 ,n,n);
  L = (kron(I,kron(I,B)) + kron(I,kron(B,I))  + kron(B,kron(I,I))...
     + spdiags(d,0,n3,n3))*spdiags(1./sqrt(d),0,n3,n3);
end
